//
//  LibytnefFileItem.m
//  TNEFsEnough
//
//  Created by Josh Jacob on 7/14/11.
//  Copyright 2011 Josh Jacob. All rights reserved.
//

#import "LibytnefFileItem.h"

@interface LibytnefFileItem()
{
}

@property (nonatomic, readwrite) int numBytes;
@property (nonatomic, strong) NSString * name;
@property (nonatomic, readwrite) Attachment * attachment;

@end

@implementation LibytnefFileItem

- (id)initWithAttachment:(Attachment *)attachment fileName:(NSString *)fileName size:(int)size
{
    self = [super init];
    if (self) {
    
        self.numBytes = size;
        self.name = fileName;
        self.attachment = attachment;
    }
    
    return self;
}


- (NSString *)fileName
{
    return self.name;
}

- (NSNumber *)fileSize
{
    return [NSNumber numberWithInt:self.attachment->FileData.size];
}

- (NSString *)fileSizeAsString
{
    // return [LibytnefFileItem stringFromFileSize: self.numBytes];

	float floatSize = self.numBytes;
	if (self.numBytes < 1023)
		return([NSString stringWithFormat:@"%i bytes", self.numBytes]);
	floatSize = floatSize / 1024;
	if (floatSize < 1023)
		return([NSString stringWithFormat:@"%1.1f KB", floatSize]);
	floatSize = floatSize / 1024;
	if (floatSize < 1023)
		return([NSString stringWithFormat:@"%1.1f MB", floatSize]);
	floatSize = floatSize / 1024;
    
	// Add as many as you like
    
	return([NSString stringWithFormat:@"%1.1f GB", floatSize]);
}

- (NSData *)fileData
{
    return [[NSData alloc] initWithBytes:self.attachment->FileData.data length:self.attachment->FileData.size];
}

@end
