//
//  LibytnefHelper.h
//  TNEFsEnough
//
//  Created by Josh Jacob on 10/19/11.
//  Copyright 2011 Josh Jacob. All rights reserved.
//

#import "tnef-types.h"
#import "tnef-errors.h"

@interface LibytnefHelper : NSObject {
    
@private
    
    // libytnef data
    TNEFStruct tnefStruct;
    char * cStringPath;
    int parseResult;
    
    // internal tnef data
    NSString * from;
    NSString * subject;
    NSDate * date;
    NSAttributedString *body;
    NSAttributedString * bodyRTF;
    NSString *bodyHTML;
    BOOL bodyIsHTML;
    
    NSMutableArray * fileItems;
}

@property (assign) int parseResult;
@property (nonatomic, strong) NSString * from;
@property (nonatomic, strong) NSString * subject;
@property (nonatomic, strong) NSDate * date;
@property (nonatomic, strong) NSAttributedString *body;
@property (nonatomic, strong) NSAttributedString * bodyRTF;
@property (nonatomic, strong) NSString *bodyHTML;
@property (readwrite) BOOL bodyIsHTML;
@property (nonatomic, strong) NSMutableArray * fileItems;

-(id) initWithFile: (NSURL *) file;

@end

#pragma mark - private methods

@interface LibytnefHelper ()

- (void)parse;

@end
