//
//  LibytnefNestedTaskItem.m
//  TNEFsEnoughLib
//
//  Created by Josh Jacob on 3/27/14.
//  Copyright (c) 2014 Josh Jacob. All rights reserved.
//

#import "LibytnefNestedTaskItem.h"

#import "LibytnefNestedHelper.h"
// #import "CFData-OFFileIO.h"

// void SaveVTask(TNEFStruct TNEF, FILE *file);

@interface LibytnefNestedTaskItem()
{
}

@property (nonatomic, readwrite) TNEFStruct * nestedMessage;
//@property (nonatomic, strong) NSMutableData *data;
@property (nonatomic, strong) NSString *dataString;

@end

@implementation LibytnefNestedTaskItem

- (id)initWithNestedMessage:(TNEFStruct *)nestedMessage
{
    self = [super init];
    if (self) {
        self.nestedMessage = nestedMessage;
        
//        self.data = [[NSMutableData alloc] init];
//        CFErrorRef *outError = nil;
//        FILE *file = OFDataCreateReadWriteStandardIOFile((CFMutableDataRef) self.data, outError);
//        SaveVTask(*nestedMessage, file);
//        self.dataString = [NSString stringWithCString:self.data.bytes encoding:NSWindowsCP1252StringEncoding];

        self.dataString = [LibytnefNestedHelper SaveVTask:*self.nestedMessage];
        // NSLog(@"%@", self.dataString);
    }
    
    return self;
}

- (NSString *)fileName
{
    NSString *subject = @"Untitled.ics";
    if (self.nestedMessage->subject.size > 0) {
        subject = [NSString stringWithFormat:@"%@.ics", [NSString stringWithCString:self.nestedMessage->subject.data encoding:NSWindowsCP1252StringEncoding]];
    }
    return subject;
}

- (NSNumber *)fileSize
{
    return [NSNumber numberWithUnsignedLong:self.dataString.length];
}

- (NSString *)fileSizeAsString
{
    // return [LibytnefFileItem stringFromFileSize: self.numBytes];
    
    unsigned long size = (self.dataString != nil ? self.dataString.length : 0);
	float floatSize = size;
	if (size < 1023)
		return([NSString stringWithFormat:@"%lu bytes", size]);
	floatSize = floatSize / 1024;
	if (floatSize < 1023)
		return([NSString stringWithFormat:@"%1.1f KB", floatSize]);
	floatSize = floatSize / 1024;
	if (floatSize < 1023)
		return([NSString stringWithFormat:@"%1.1f MB", floatSize]);
	floatSize = floatSize / 1024;
    
	// Add as many as you like
    
	return([NSString stringWithFormat:@"%1.1f GB", floatSize]);
}

- (NSData *)fileData
{
    return [self.dataString dataUsingEncoding:NSUTF8StringEncoding];
}

@end
